<!-- DevNotes.cfm by hal.helms@teamallaire.com and jeff@grokfusebox.com -->

<!---
<fusedoc fuse="DevNotes.cfm" language="ColdFusion" specification="2.0">
  <responsibilities>
    I recursively build a list of the children of a specified DevNote.
  </responsibilities>
  <properties>
    <property name="latestVersion" value="0.60" />
    <note author="hal helms" date="07 Feb 02">
    		Changed database to add field "showNote". Changed code so that, instead of deleting records, it flips the showNote field to FALSE, so that the changes are kept.
    </note>
    <note author="Jeff Peters" date="28 Jan 02" type="update">Version 0.10</note>
    <note author="Jeff Peters" date="06 Jan 02" type="update">Version 0.20</note>  
    <note author="Jeff Peters" date="20 Aug 02" type="update">Version 0.30</note>
    <note author="Jeff Peters" date="22 Aug 02" type="update">Version 0.40 - fixed bug in form submission for tracking by fuseaction.</note>
    <note author="Jeff Peters" date="15 Nov 05" type="update" email="jeff@grokfusebox.com">
      Version 0.50
      Requires udfMakeTree.cfm instead of CFX_Make_Tree.dll 
      Requires DevNotesFindKids.cfm by jeff@grokfusebox.com
      Adds dateEntered to Notes database table
    </note>
    <note author="Robert Blackburn" date="02 May 06" type="update">Version 0.60 - Fixed dateEntered bug and tested SQL Server compatibility.</note>
  </properties>
  <io>
    <in>
      <number name="noteID" precision="Integer" />
    </in>
    <out>
      <list name="kidList" scope="request" comments="List of child noteIDs"
    </out>
  </io>
</fusedoc>
--->

<cfoutput>

<!--- Make sure state mgm't is set up --->
<cfif NOT IsDefined( 'application.applicationName' )>
	<cfapplication 
		name="DevNotes" 
		clientmanagement="Yes" 
		sessionmanagement="Yes">
</cfif>

<!--- Append any attributes, form variables, and url variables to the request scope, overwriting if necessary. --->
<cfset lstScopes = "attributes,form">
<cfloop list="#lstScopes#" index="thisScope">
  <cfif IsDefined("#thisScope#")>
    <!--- If no request-scoped variables exist, create one so the request structure exists. --->
    <cfif not isDefined("request")>
      <cfset request.dnRequestExists = True>
    </cfif>
    <cfset temp=StructAppend(request, Evaluate(thisScope), "Yes")>
  </cfif>
</cfloop>

<cfif isDefined("url.fuseaction")>
  <cfset request.fuseaction = url.fuseaction>
</cfif>

<!--- Set any of the required vars that weren't sent in as attributes. --->
<cfparam name="request.DevNotesDSN" default="DevNotes">
<cfparam name="request.DevTesting" default="True">
<cfparam name="request.loseIdentity" default="FALSE">
<cfparam name="request.deleteNote" default="FALSE">
<cfparam name="request.parentID" default="0">
<cfparam name="request.deleteNote" default="FALSE">
<cfparam name="request.dumpVars" default="FALSE">
<cfparam name="request.attributeToKeyOn" default="url">
<cfparam name="request.noteText" default="">
<cfparam name="request.devID" default="">
<cfparam name="request.fuseaction" default="notInURL">


<cfif lcase(request.attributeToKeyOn) EQ "url">
  <cfset request.URL = "#cgi.script_name#">
</cfif>

<cfif request.loseIdentity>
	<cfset DeleteClientVariable( 'devID' )>
</cfif>

<!--- @COMMENT: If user wants to add an ID, save it as a client var. --->
<cfparam name="client.devID" default="??">
<cfif len( request.devID )>
	<cfset client.devID = Trim( request.devID )>
  <cfset request.devID = "??">
</cfif>

<!--- @COMMENT: Insert a new or related note if one is passed to me.--->
<cfif Len( Trim( request.noteText ) )>
	<cfquery datasource="#request.DevNotesDSN#">
		INSERT INTO Notes(
			noteText,
			parentID,
			myLevel,
			applicationName,
			author,
			attributeToKeyOn,
			aKeyValue,
			showNote,
			dateEntered
		)
		VALUES(
			'#request.noteText#',
			#request.parentID#,
			#request.noteLevel#,
			'#request.devAppName#',
			'#client.devID#',
			'#request.attributeToKeyOn#',
			'#Evaluate( 'request.' & request.attributeToKeyOn )#',
			1,
			#Now()#
		)
	</cfquery>
  <cfset request.noteText = "">
  <cfset request.parentID = 0>
</cfif>


<cfif request.deleteNote>
	<!--- Build a list of the note and its descendants. --->
	<cfset request.kidList = "#request.noteID#">
	<cf_DevNotesFindKids noteID="#request.noteID#">
 	
	<!--- Delete the note and its descendants --->
	<cfquery datasource="#request.DevNotesDSN#">
		UPDATE Notes 
		   SET showNote = 0
     WHERE noteID IN ( #request.kidList#  )
	</cfquery>	
	
  <cfset request.deleteNote = False>
</cfif>

<!--- Get notes from DevNotes database --->
<cfquery name="Notes" datasource="#request.DevNotesDSN#">
	SELECT NoteID as ItemID, 
		     ParentID as ParentItemID, 
		     NoteText as Description
	  FROM Notes 
 	 WHERE applicationName = '#request.devAppName#'
	   AND attributeToKeyOn = '#request.attributeToKeyOn#'
	   AND aKeyValue = '#Evaluate( 'request.' & request.attributeToKeyOn )#'
		AND showNote = 1
ORDER BY NoteID
</cfquery>

<!--- @COMMENT: Display the notes --->
<cfinclude template="udfMakeTree.cfm">
<cfset Notes = maketree(Notes, "ItemID", "ParentItemID")>


<!--- @COMMENT: FORM starts here --->
<cfparam name="request.noteLevel" default="1">
<cfparam name="request.noteID" default="">
<cfparam name="request.parentID" default="0">
<cfif request.parentID is 0>
	<cfset request.noteLevel = 1>
</cfif>

<table align="center" width="80%" border="3" bordercolor="##800000" cellpadding="6">
<tr>
<td align="center">
<font color="Silver"> D E V E L O P E R &nbsp;&nbsp;&nbsp;&nbsp;N O T E S</font>
</td>
</tr>
<tr>
<td align="center">
<form action="#cgi.script_name#?#client.urltoken#" method="post" name="devForm">
	<input type="Hidden" name="isNewNote" value="TRUE">
	<input type="Hidden" name="parentID" value="#request.parentID#">
	<input type="Hidden" name="noteID" value="#request.noteID#">
	<input type="Hidden" name="noteLevel" value="#request.noteLevel#">
	<input type="Hidden" name="deleteNote" value="FALSE">
  <input type="Hidden" name="attributeToKeyOn" value="#request.attributeToKeyOn#">
	<input type="Hidden" name="#request.attributeToKeyOn#" value="#Evaluate( 'request.' & request.attributeToKeyOn )#">
	
	<!--- @COMMENT: Let user provide ID --->
<cfif client.devid is "??">
	<h3>Your initials or other ID</h3><br>
	<input name="devID" type="Text">
</cfif>

<!--- @COMMENT: Provide form for new/responding note --->
<cfparam name="request.isNewNote" default="TRUE">
<cfif request.isNewNote>
	<h3>New note</h3>	
<cfelse>
		<h3>Follow-up note</h3>	
</cfif>

<textarea name="noteText" cols="40" rows="2"></textarea><br>
<input type="Submit" value=" .ok " style="font-family:Verdana,sans-serif;font-size:8pt;font-weight:bold">

</form>
</td>
</tr>
<tr>
<td>
<cfloop query="Notes">
	
	<!--- @COMMENT: Funkadelic because of the requirements of the CFX_Make_Tree --->
	<cfquery datasource="#request.DevNotesDSN#" name="GetLevels">
		SELECT myLevel, author FROM Notes WHERE noteID = #ItemID#
	</cfquery>
	
	<cfloop from="1" to="#DecrementValue( GetLevels.myLevel )#" index="i">
		<font color="white">&gt;</font>
	</cfloop>
  <span style="font-family:Verdana,sans-serif;font-size:8pt;font-weight:bold"> 
	+ 
  <a title="Follow-up" href="javascript:document.devForm.parentID.value='#ItemID#';document.devForm.isNewNote.value='FALSE';document.devForm.noteLevel.value='#IncrementValue( GetLevels.myLevel )#';document.devForm.submit();">F</a>
  <a title="Delete" href="javascript:document.devForm.parentID.value='#ItemID#';javascript:document.devForm.noteID.value='#ItemID#';document.devForm.deleteNote.value='TRUE';document.devForm.submit();">X</a>
  &nbsp;&nbsp;&nbsp;
  </span>
  <span style="font-family:Verdana,sans-serif;font-size:8pt;font-weight:bold">
	#GetLevels.author#: #Description#<Br> 
  </span>

</cfloop>

</td>
</tr>
<tr>
<td align="center">
<form action="#cgi.script_name#?#client.urltoken#" method="post">
	<input type="Hidden" name="loseIdentity" value="TRUE">
	<input type="Submit" value="Log in as someone else" style="font-family:Verdana,sans-serif;font-size:8pt;font-weight:bold">
</form>
</td>
</tr>
</table>
</cfoutput>